﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;

namespace TrailMapManager.Common.Converters
{
    public class AddingConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            double p;
            if (double.TryParse(parameter as string, out p))
            {
                return (double)value + p;
            }
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            double p;
            if (double.TryParse(parameter as string, out p))
            {
                return (double)value - p;
            }
            return value;
        }
    }
}
